NAV Navbar
shell

Introduction

The FP API is designed to be easily predictable and have consistency across all the resources. It accepts json in the request body and returns a json representation of the resource. We use standard HTTP response codes and HTTP verbs.

You can access FP API in sandbox and production modes separately. Use the following base URLs: Sandbox (for testing): https://s.finprim.com Production (for live transactions): https://api.fintechprimitives.com

MasterData

Pincode

curl "https://s.finprim.com/api/onb/pincodes/560102"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer JWTTOKEN"

The above command returns JSON structured like this:

{
  "code": "560102",
  "city": "Bangalore South",
  "district": "Bangalore",
  "state_name": "Karnataka",
  "country_ansi_code": "IN",
  "_links": [
    {
      "href": "https://s.finprim.com/api/onb/pincodes/560102",
      "rel": "self",
      "method": "GET"
    }
  ]
}

This endpoint retrieves details of the given pincode

HTTP Request

GET https://s.finprim.com/api/onb/pincodes/{pincode}

Response Object

Attribute Type Description
code string Pincode of the location
city string City
district string District
state_name string State
country_ansi_code string ANSI code of the Country

States

curl "https://s.finprim.com/api/onb/states"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer JWTTOKEN"

The above command returns JSON structured like this:

{
  "states": [
    {
      "name": "Karnataka",
      "state_code": "KA",
      "country_ansi_code": "IN"
    }
  ]
}

This endpoint retrieves all states of India which are updated in the system

HTTP Request

GET https://s.finprim.com/api/onb/states

Response Object

Attribute Type Description
name string name of the state
state_code string state code associated with the state
country_ansi_code string ANSI code of the country

Countries

curl "https://s.finprim.com/api/onb/countries"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer JWTTOKEN"

The above command returns JSON structured like this:

{
  "countries": [
    {
      "name": "India",
      "ansi_code": "IN"
    }
  ]
}

This endpoint retrieves the list of countries updated in the system

HTTP Request

GET https://s.finprim.com/api/onb/countries

Response Object

Attribute Type Description
name string name of the country
country_ansi_code string ANSI code of the country

IFSC

curl "https://s.finprim.com/api/onb/ifsc_codes/ICIC0000611"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer JWTTOKEN"

The above command returns JSON structured like this:

{
  "ifsc_code": "ICIC0000611",
  "micr_code": "0000000",
  "branch_name": "gudivada",
  "branch_address": "ICICI BANK LTD , D NO-11-218, NENIPLAZA, ELURU ROAD, GUDIVADA. 521301",
  "bank_name": "ICICI",
  "contact": "SUMANTH SAGI 08674-247355",
  "city": "guivada",
  "district": "KRISHNA",
  "state": "ANDHRA PRADESH"
}

This endpoint retrieves details of the given ifsc_code updated in the system

HTTP Request

GET https://s.finprim.com/api/onb/ifsc_codes/{ifsc_code}

Response Object

Attribute Type Description
ifsc_code string IFSC code associated with the bank
micr_code string MICR code associated with the bank (if available)
branch_name string branch name of the bank
branch_address string branch address of the bank
bank_name string name of the bank
contact string contact details of the bank (if available)
city string city in which bank is located
district string district in which bank is located
state string state in which bank is located

Fund Scheme - V2

This API must be used to fetch information about a mutual fund scheme supported by a particular gateway by providing an isin. At present, only scheme information of cybrillapoa gateway can be fetched.

curl "https://s.finprim.com/v2/mf_scheme_plans/cybrillapoa/INF179KA1JD2?expand=mf_scheme,mf_fund "
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer JWTTOKEN"

The above command returns JSON structured like this:

{
  "object": "mf_scheme_plan",
  "gateway": "cybrillapoa",
  "mf_scheme": {
    "name": "UTI - LIQUID FUND"
  },
  "mf_fund": {
    "name": "UTI MUTUAL FUND"
  },
  "isin": "INF789F1AF85",
  "type": "regular",
  "option": "growth",
  "idcw_option": null,
  "active": true,
  "thresholds": [
    {
      "type": "lumpsum",
      "amount_min": 100.0,
      "additional_amount_min": 100.0,
      "amount_max": 999999999.0,
      "additional_amount_max": 999999999.0,
      "amount_multiples": 1.0,
      "additional_amount_multiples": 1.0
    },
    {
      "type": "withdrawal",
      "amount_min": 1.0,
      "amount_max": 999999999.0,
      "amount_multiples": 1.0,
      "units_min": 0.001,
      "units_max": 999999999.0,
      "units_multiples": 0.001
    },
    {
      "type": "instant_withdrawal",
      "amount_min": 1.0,
      "amount_multiples": 1.0
    },
    {
      "type": "switch_in",
      "amount_min": 100.0,
      "amount_max": 999999999.0,
      "amount_multiples": 1.0
    },
    {
      "type": "switch_out",
      "amount_min": 1.0,
      "amount_max": 999999999.0,
      "amount_multiples": 1.0,
      "units_min": 0.001,
      "units_max": 999999999.0,
      "units_multiples": 0.001
    },
    {
      "type": "sip",
      "frequency": "monthly",
      "amount_min": 100.0,
      "amount_max": 999999999.0,
      "amount_multiples": 1.0,
      "installments_min": 6,
      "dates": [
        1,
        2,
        3,
        4,
        5,
        6,
        7,
        8,
        9,
        10,
        11,
        12,
        13,
        14,
        15,
        16,
        17,
        18,
        19,
        20,
        21,
        22,
        23,
        24,
        25,
        26,
        27,
        28
      ]
    },
    {
      "type": "swp",
      "frequency": "monthly",
      "amount_min": 500.0,
      "amount_max": 999999999.0,
      "amount_multiples": 1.0,
      "installments_min": 3,
      "dates": [
        1,
        2,
        3,
        4,
        5,
        6,
        7,
        8,
        9,
        10,
        11,
        12,
        13,
        14,
        15,
        16,
        17,
        18,
        19,
        20,
        21,
        22,
        23,
        24,
        25,
        26,
        27,
        28
      ]
    },
    {
      "type": "stp_in",
      "frequency": "monthly",
      "amount_min": 1000.0,
      "amount_max": 999999999.0,
      "amount_multiples": 1.0,
      "installments_min": 6,
      "dates": [
        1,
        2,
        3,
        4,
        5,
        6,
        7,
        8,
        9,
        10,
        11,
        12,
        13,
        14,
        15,
        16,
        17,
        18,
        19,
        20,
        21,
        22,
        23,
        24,
        25,
        26,
        27,
        28
      ]
    },
    {
      "type": "stp_out",
      "frequency": "monthly",
      "amount_min": 1000.0,
      "amount_max": 999999999.0,
      "amount_multiples": 1.0,
      "installments_min": 6,
      "dates": [
        1,
        2,
        3,
        4,
        5,
        6,
        7,
        8,
        9,
        10,
        11,
        12,
        13,
        14,
        15,
        16,
        17,
        18,
        19,
        20,
        21,
        22,
        23,
        24,
        25,
        26,
        27,
        28
      ]
    }
  ]
}

HTTP Request

GET /v2/mf_scheme_plans/:gateway/:isin?expand=mf_scheme,mf_fund

Request Parameters

Path Parameters:

Name Mandatory Type Comments
gateway yes string The identifier for the order gateway. Example: cybrillapoa
isin yes string The ISIN code for the scheme plan. Example: INF789F1AF85

Query Parameters:

Name Mandatory Type Comments
expand yes string Mandatory Supported values: mf_scheme, mf_fund

Response Object

Fund Scheme Plan Response Object

Attribute Type Description
object string Type of the object returned (value : mf_scheme_plan)
gateway string Allowed order gateways. Value supported : cybrillapoa
mf_scheme.name string Name of the mutual fund
mf_fund.name string Parent mutual fund name
isin string ISIN of the scheme
type string Plan type of the scheme. Possible values: regular, direct
option string Option of the scheme. Possible values: growth,bonus,idcw,idcw_daily,idcw_weekly,idcw_monthly,idcw_fortnightly,idcw_quarterly,idcw_half_yearly,idcw_annual,idcw_flexi
idcw_option string IDCW option of the scheme. Value will be null if option is growth. Possible values:reinvestment, payout
active boolean If the scheme is active, value is 'true' else, value is 'false'
thresholds array Array defining limits for different transaction types

Thresholds params

Attribute Type Description
type string Type of transaction. Possible values:lumpsum, withdrawal, instant_withdrawal, switch_in, switch_out, sip, swp, stp_in, stp_out
frequency string Frequency of transaction. Possible values: daily, calendar_day_daily, monthly
amount_min decimal Minimum allowed amount
additional_amount_min decimal Minimum additional amount
amount_max decimal Maximum allowed amount
additional_amount_max decimal Maximum additional amount
amount_multiples decimal Amount must be a multiple of this value
additional_amount_multiples decimal Additional amount must be multiple of this value
installments_min integer Minimum number of installments
units_min decimal Minimum number of units
units_max decimal Maximum number of units
unit_multiples decimal Units must be a multiple of this value
dates array Installment dates for SIP, SWP, STP_IN, STP_OUT transactions

AMCs

curl "https://s.finprim.com/api/oms/amcs"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer JWTTOKEN"

The above command returns JSON structured like this:

{
  "_links": {
    "self": {
      "href": "https://s.finprim.com/oms/api/amcs"
    }
  },
  "amcs": [
    {
      "id": 1,
      "name": "Axis MF",
      "active": true,
      "amc_code": null
    }
  ]
}

This endpoint retrieves all the AMCs.

HTTP Request

GET https://s.finprim.com/api/oms/amcs

Response Object

Attribute Type Description
id integer Id of the AMC
name string Name of the AMC
active boolean Status of the AMC configured
amc_code string Unique code associated with AMC

Authentication

Overview

FP uses OAuth 2.0 protocols for authentication. At present, FP supports the following authentications

Types of authentication

Endpoints for authentication:

GET /v2/auth/{tenant_name}/auth POST /v2/auth/{tenant_name}/token

Token Object

Token object encapsulates the access_token that is required to access FP APIs. You get a token object after successful authentication(Tenant authentication or Investor authentication or Partner authentication).

{
  "access_token": "eyJhbGciOiJSUzI1NiIsInR5cCIgOiAiSldUIiwia2lkIiA6ICIyUVVoVl9aaGVyQmRHMjVQMl83cmdVaDYxcS1WXzZ0NzNmO",
  "expires_in": 1800,
  "refresh_expires_in": 0,
  "token_type": "Bearer",
  "not-before-policy": 0,
  "scope": "default"
}
Attribute Type Comments
access_token string The access token contains the security credentials for a login session and identifies the user. You need to pass this in the header at the time of invoking FP APIs.
expires_in long It specifies the validity of the access token in seconds.
refresh_token string Not applicable for tenant login and reserved for Partner and Investor authentication.
refresh_expires_in long Not applicable for tenant login and reserved for Partner and Investor authentication.
token_type string The token type will always be Bearer. This type of authentication means that any Bearer of an access token can access FP APIs.
not-before-policy (for internal use) int not-before-policy ensures that any tokens issued before that time become invalid.
scope (for internal use) string The scope is a mechanism in OAuth 2.0 to limit an application's access to a user's account.

Tenant Authentication

Getting Started

  1. Write an email to fpsupport@cybrilla.com and register yourself as OAuth 2.0 client for tenant authentication purposes.
  2. We will share the client_id, client_secret, and tenant_name.
  3. Use POST /v2/auth/{tenant_name}/token endpoint and provide client_id, client_secret, and tenant_name to generate token object.
  4. Use the generated token object's access_token to access FP APIs.
  5. Every token object will have an expiry time. Ensure that you are creating a new token object if the existing token object is expired.

Getting tenant token

For tenant tokens, we are using Client Credentials flow. This flow is recommended for server-side (aka confidential) client applications with no end-user, which normally describes server-to-server communication. The application needs to securely store its client ID and secret and pass them in exchange for an access token.

POST /v2/auth/{tenant_name}/token

curl \
-H 'accept: application/json' \
-H 'content-type: application/x-www-form-urlencoded' \
-d "client_id=XXX" \
-d "client_secret=XXXXXXX" \
-d "grant_type=client_credentials" \
"{baseUrl}/v2/auth/{tenant_name}/token"

Success response:

{
  "access_token": "eyJhbGciOiJSUzI1NiIsInR5cCIgOiAiSldUIiwia2lkIiA6ICIyUVVoVl9aaGVyQmRHMjVQMl83cmdVaDYxcS1WXzZ0NzNmO",
  "expires_in": 1800,
  "refresh_expires_in": 0,
  "token_type": "Bearer",
  "not-before-policy": 0,
  "scope": "default"
}

Headers

Parameter Mandatory Default value
accept yes - application/json
content-type yes - application/x-www-form-urlencoded

Request Parameters

Parameter Mandatory Default Description
client_id yes - client_id provided by fintechprimitives
client_secret yes - client_secret provided by fintechprimitives
grant_type yes - client_credentials

Using token to make API call

FP API uses bearer auth to authenticate all the API calls. You need to send the following header in all your API calls along with your access token:

Authorization: Bearer ACCESS_TOKEN

Efficient Usage of JWT Tokens

Overview

To ensure security and optimize performance, it's crucial to avoid excessive creation of JWT tokens. Instead, clients should rely on the token's expiry attribute and use the same token for multiple requests until it expires.

** Best Practices for Clients**

Reuse Tokens Until Expiry

Minimize Unnecessary Authentication Calls

Implement Token Caching

Common Mistakes to Avoid

❌ Requesting a new token on every API call.

❌ Ignoring the expiry attribute and assuming the token is always invalid.

❌ Storing tokens insecurely, leading to security risks.

Partners

Represents a FP Partner entity. For example, a partner could be a sub-broker.

Endpoints:

POST /v2/partners
GET /v2/partners/:id
GET /v2/partners

Partner Object

{
  "object": "partner",
  "id": "ptnr_8afb5028f1574e639b58722becd70aa3",
  "name": "ABC Distributors",
  "license_code": "ARN-98345",
  "created_at": "2023-08-21T16:07:02+05:30",
  "default_broker_codes": {
    "karvy": "ATID",
    "cams": "ATID"
  },
  "location": "Bangalore",
  "ref_no": "34768322346",
  "mobile": "9036427846",
  "email": "abc_distributors@gmail.com",
  "contact_person_name": "Abraham N",
  "expiry_date": "2028-09-01",
  "euins": [
    "E23432"
  ]
}
Attribute Type Comments
object string Value is partner. String representing the object type. Objects of the same type share the same value
id string Unique identifier for the object.
name string Full name of the partner
license_code string License code of the partner (RIA/ARN code)
default_broker_codes string Default RTA broker codes of the partner
location string Partner registration location
ref_no string Internal reference number provided by the tenant for a partner.
mobile string Mobile number of the partner
email string Email ID of the partner
contact_person_name string Contact person name from the partner office
expiry_date string The expiration date of the license code of the partner if any. Format: YYYY-MM-DD
euins string Employee Unique Identification Number of the partner can be used while placing an order
created_at string Creation timestamp

Create a Partner

curl -X POST "https://s.finprim.com/v2/partners"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer ACCESS_TOKEN"

JSON Request:

{
  "name": "ABC Distributors",
  "license_code": "ARN-98345",
  "default_broker_codes": {
    "karvy": "ATID",
    "cams": "ATID"
  },
  "location": "Bangalore",
  "ref_no": "34768322346",
  "mobile": "9036427846",
  "email": "abc_distributors@gmail.com",
  "contact_person_name": "Abraham N",
  "expiry_date": "2028-09-01",
  "euins": [
    "E23432"
  ]
}

JSON Response:

{
  "object": "partner",
  "id": "ptnr_8afb5028f1574e639b58722becd70aa3",
  "name": "ABC Distributors",
  "license_code": "ARN-98345",
  "created_at": "2023-08-21T16:07:02+05:30",
  "default_broker_codes": {
    "karvy": "ATID",
    "cams": "ATID"
  },
  "location": "Bangalore",
  "ref_no": "34768322346",
  "mobile": "9036427846",
  "email": "abc_distributors@gmail.com",
  "contact_person_name": "Abraham N",
  "expiry_date": "2028-09-01",
  "euins": [
    "E23432"
  ]
}

Request Parameters

Name Mandatory Type Comments
name no string
license_code yes string
default_broker_codes yes hash Supported keys cams and karvy. Use to populate sub-broker broker code. Once set, this cannot be modified
location yes string
ref_no no string
mobile no string
email no string
contact_person_name no string
expiry_date no string
euins conditional string[] List of EUINs for the partner. Mandatory when partner is an ARN holder

Fetch a Partner

GET /partners/:id

curl -X GET "https://s.finprim.com/v2/partners/ptnr_8afb5028f1574e639b58722becd70aa3"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer ACCESS_TOKEN"

This API is used to fetch a partner by its identifier.

Query Parameters

Name Mandatory Type Comments
id yes string id of the partner

JSON Response:

{
  "object": "partner",
  "id": "ptnr_8afb5028f1574e639b58722becd70aa3",
  "name": "ABC Distributors",
  "license_code": "ARN-98345",
  "created_at": "2023-08-21T16:07:02+05:30",
  "default_broker_codes": {
    "karvy": "ATID",
    "cams": "ATID"
  },
  "location": "Bangalore",
  "ref_no": "34768322346",
  "mobile": "9036427846",
  "email": "abc_distributors@gmail.com",
  "contact_person_name": "Abraham N",
  "expiry_date": "2028-09-01",
  "euins": [
    "E23432"
  ]
}

Search a Partner

GET /partners

curl -X GET "https://s.finprim.com/v2/partners?code=ARN-13452"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer ACCESS_TOKEN"

This API can be use to search partner.

JSON Response:

{
  "object": "list",
  "data": [
    {
      "object": "partner",
      "id": "ptnr_8afb5028f1574e639b58722becd70aa3",
      "name": "ABC Distributors",
      "license_code": "ARN-98345",
      "created_at": "2023-08-21T16:07:02+05:30",
      "default_broker_codes": {
        "cams": "ATID",
        "karvy": "ATID"
      },
      "location": "Bangalore",
      "ref_no": "34768322346",
      "mobile": "9036427846",
      "email": "abc_distributors@gmail.com",
      "contact_person_name": "Abraham N",
      "expiry_date": "2028-09-01",
      "euins": [
        "E23432"
      ]
    }
  ]
}

Query Parameters

Name Mandatory Type Comments
code yes string Licence code of the partner

Files

Create a file

curl -X POST "https://s.finprim.com/files"
-H "x-tenant-id: <tenant name>"
-H "Authorization: Bearer JWTTOKEN"
-F
'
"file" : {file_to_upload}
'

The above command returns JSON structured like this:

{
  "object": "file",
  "id": "224f380c-d8f9-6f15-b2d9-27968a75f491",
  "created_at": "2018-05-13T17:53:58+05:30",
  "filename": "bob_dl_back.jpg",
  "content_type": "image/jpeg",
  "purpose": null,
  "byte_size": 4501312,
  "url": "https://files.fp.com/bob_dl_back.jpg"
}

Endpoint is used to upload POI, POA, photo, video, and signature files.

HTTP Request

POST https://s.finprim.com/files

Query Parameters

Parameter Mandatory Default Description
file yes - File must be in jpg, jpeg, png, mp4, webm, pdf and tiff format and size should not exceed 10MB.
purpose no - Notes.

Fetch a file

curl "https://s.finprim.com/files/870d11d1-c63b-41ca-362a-c8062f4efc71"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer JWTTOKEN"

Endpoint is used to fetch details of a particular file.

{
  "object": "file",
  "id": "224f380c-d8f9-6f15-b2d9-27968a75f491",
  "created_at": "2018-05-13T17:53:58+05:30",
  "filename": "bob_dl_back.jpg",
  "content_type": "image/jpeg",
  "purpose": null,
  "byte_size": 4501312,
  "url": "https://files.fp.com/bob_dl_back.jpg"
}

Endpoint is used to fetch details of a particular file.

HTTP Request

GET https://s.finprim.com/files/{id}

Query Parameters

Parameter Mandatory Default Description
id yes - file id returned from upload file api.

List all files

curl -X GET "https://s.finprim.com/files"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer JWTTOKEN"

Endpoint fetches the list of all the files.

{
  "object": "list",
  "data": [
    {
      "object": "file",
      "id": "d2784e7c-a414-4da8-954c-911fe425094a",
      "created_at": "2018-01-29T13:07:32+05:30",
      "filename": "file1.png",
      "content_type": "image/png",
      "purpose": "kyc approve document",
      "byte_size": 127343,
      "url": "https://files.fp.com/file1.png"
    },
    {
      "object": "file",
      "id": "81d631b2-4bc7-49b9-a11d-ff10110e484b",
      "created_at": "2018-01-29T13:44:56+05:30",
      "filename": "undraw_deliveries_131a.png",
      "content_type": "image/png",
      "purpose": "kyc document",
      "byte_size": 73441,
      "url": "https://files.fp.com/undraw_deliveries_131a.png"
    }
  ]
}

Endpoint fetches the list of all the files.

HTTP Request

GET https://s.finprim.com/files

Investor Profiles

The Investor Profile object lets you manage the profile information of the investor like addresses, bank accounts, contact details, FATCA declarations, and other demographic details.

NOTE: This is currently available only for customers who are transacting via the RTA route.

Endpoints:

POST /v2/investor_profiles
PATCH /v2/investor_profiles
GET /v2/investor_profiles/:id
GET /v2/investor_profiles

Investor Profile Object

Investor Profile Object

{
  "object": "investor_profile",
  "id": "invp_9abd706565144b83947f4b498bc95e98",
  "type": "individual",
  "tax_status": "resident_individual",
  "name": "Tony Soprano",
  "date_of_birth": "2002-09-18",
  "gender": "male",
  "occupation": "business",
  "pan": "DWEPS2837G",
  "guardian_name": null,
  "guardian_date_of_birth": null,
  "guardian_pan": null,
  "signature": null,
  "country_of_birth": "IN",
  "place_of_birth": "IN",
  "first_tax_residency": {
    "country": "IN",
    "taxid_type": "pan",
    "taxid_number": "DWEPS2837G"
  },
  "second_tax_residency": null,
  "third_tax_residency": null,
  "fourth_tax_residency": null,
  "source_of_wealth": "salary",
  "income_slab": "upto_1lakh",
  "pep_details": "not_applicable",
  "employer": null,
  "ip_address": "192.92.12.39",
  "created_at": "2022-07-07T10:28:53+05:30"
}

Investor profiles let you store information about a particular investor and use this information for a folio creation.

Investor object attributes

Attribute Type Comments
object string Value is investor_profile. String representing the object type. Objects of the same type share the same value
id string Unique identifier of the investor_profile object
type enum Allowed values are individual
tax_status enum Allowed values are resident_individual and nri
name string Name of the investor
date_of_birth string Date of birth of the investor
gender enum Allowed values are male, female, transgender
occupation enum Allowed values are business, professional, retired, house_wife, student, public_sector_service, private_sector_service, government_service, others, agriculture, doctor, forex_dealer, service
pan string Investor's PAN. Please note that PAN once set cannot be modified.
guardian_name string Name of the minor's guardian
guardian_date_of_birth string DOB of minor's guardian
guardian_pan string PAN of minor's guardian
signature string File ID to be passed here
country_of_birth string ANSI code of the birth country
place_of_birth string If country_of_birth=IN, then by default IN would be passed if no value is given
first_tax_residency hash Details of the investor's first tax residency
second_tax_residency hash Details of the investor's second tax residency
third_tax_residency hash Details of the investor's third tax residency
fourth_tax_residency hash Details of the investor's fourth tax residency
source_of_wealth enum Allowed values are - salary, business, gift, ancestral_property, rental_income, prize_money, royalty, others

NOTE: If investor.tax_status=resident_minor or investor.tax_status=non_resident_minor_nro, then Guardian's source of wealth to be mentioned here.
income_slab enum Investor's income slab.

Allowed values are - upto_1lakh, above_1lakh_upto_5lakh, above_5lakh_upto_10lakh, above_10lakh_upto_25lakh, above_25lakh_upto_1cr, above_1cr

NOTE: If investor.tax_status=resident_minor or investor.tax_status=non_resident_minor_nro, then Guardian's source of wealth to be mentioned here.
pep_details enum To determine if the investor is politically exposed or related to a politically exposed person.

Allowed values are - pep_exposed, pep_related, not_applicable
employer string Investor Profile ID of the employer

NOTE: The attribute employer is available under beta program. You can skip this attribute for folio creation
ip_address string IP address from where the request for investor_profile object creation was made
created_at string Creation timestamp

Tax residency hash

This hash will contain the details of an investor's tax residency. An investor can provide up to four tax residency details in the investor_profile object.

Name Type Remarks
country string ANSI code of the tax residency country
taxid_type enum Tax Identification type.

If country is IN, then allowed values are - passport, election_id, pan, id_card, driving_license, aadhaar_letter, nrega_job_card, others, not_categorized, tin

Else, allowed values are - passport, id_card, driving_license, others, not_categorized, tin
taxid_number string Tax Identification number issued against ID mentioned in taxid_type

Create an Investor Profile

curl -X POST "https://s.finprim.com/v2/investor_profiles"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer ACCESS_TOKEN"
  -d '{json_request}'

JSON Request

{
  "type": "individual",
  "tax_status": "resident_individual",
  "name": "Tony Soprano",
  "date_of_birth": "2002-09-18",
  "gender": "male",
  "occupation": "business",
  "pan": "DWEPS2837G",
  "country_of_birth": "IN",
  "place_of_birth": "IN",
  "use_default_tax_residences": "false",
  "first_tax_residency": {
    "country": "IN",
    "taxid_type": "pan",
    "taxid_number": "DWEPS2837G"
  },
  "source_of_wealth": "salary",
  "income_slab": "upto_1lakh",
  "pep_details": "not_applicable",
  "ip_address": "192.92.12.39"
}

JSON Response

{
  "object": "investor_profile",
  "id": "invp_9abd706565144b83947f4b498bc95e98",
  "type": "individual",
  "tax_status": "resident_individual",
  "name": "Tony Soprano",
  "date_of_birth": "2002-09-18",
  "gender": "male",
  "occupation": "business",
  "pan": "DWEPS2837G",
  "guardian_name": null,
  "guardian_date_of_birth": null,
  "guardian_pan": null,
  "signature": null,
  "country_of_birth": "IN",
  "place_of_birth": "IN",
  "first_tax_residency": {
    "country": "IN",
    "taxid_type": "pan",
    "taxid_number": "DWEPS2837G"
  },
  "second_tax_residency": null,
  "third_tax_residency": null,
  "fourth_tax_residency": null,
  "source_of_wealth": "salary",
  "income_slab": "upto_1lakh",
  "pep_details": "not_applicable",
  "employer": null,
  "ip_address": "192.92.12.39",
  "created_at": "2022-07-07T10:28:53+05:30"
}

POST /v2/investor_profiles

This API can be used to create an investor profile.

Request Parameters

Name Mandatory Type Comments
type yes enum Allowed values are individual
tax_status no enum If type=individual, then allowed values are resident_individual and nri

Once set, this cannot be modified
name no string This should not contain any special characters or numbers

Max character length is 70
date_of_birth no string This should be in the yyyy-mm-dd format

Once set, this cannot be modified
gender no enum Allowed values are male, female, transgender
occupation no enum Allowed values are business, professional, retired, house_wife, student, public_sector_service, private_sector_service, government_service, others, agriculture, doctor, forex_dealer, service
pan no string If type=individual, then the 4th character should always be p

To set a PAN, tax_status should be present
guardian_name no string This should not contain any special characters or numbers

Can be entered only if the investor's age < 18

Max character length is 80
guardian_date_of_birth no string Can be entered only if guardian_name is present
guardian_pan no string Can be entered only if guardian_name is present
signature no string Not applicable if the order processing gateway is rta
country_of_birth no string ANSI code of the birth country

Once set, this cannot be modified
place_of_birth no string If country_of_birth=IN, then by default IN would be passed if no other value is given. This would be a mandatory requirement if country_of_birth!=IN. Max character length is 60

Once set, this cannot be modified
use_default_tax_residences no boolean true - First tax residency [first_tax_residency] will be India and the Identification type will be PAN provided that PAN is not empty. Other tax residences will be empty.
false - Allows you to override all the existing tax residency details.

Default value for this input parameter would be false
first_tax_residency no hash Details of the investor's first tax residency
second_tax_residency no hash Details of the investor's second tax residency
third_tax_residency no hash Details of the investor's third tax residency
fourth_tax_residency no hash Details of the investor's fourth tax residency
source_of_wealth no enum Allowed values are - salary, business, gift, ancestral_property, rental_income, prize_money, royalty, others

NOTE: If tax_status=resident_minor or tax_status=non_resident_minor_nro, then Guardian's source of wealth to be mentioned here.
income_slab no enum Investor's income slab.

Allowed values are - upto_1lakh, above_1lakh_upto_5lakh, above_5lakh_upto_10lakh, above_10lakh_upto_25lakh, above_25lakh_upto_1cr, above_1cr
pep_details no enum To determine if the investor is politically exposed or related to a politically exposed person. Allowed values are - pep_exposed, pep_related, not_applicable
ip_address no string Provide IP address of the server through which the request to create this investor profile was made



Tax residency hash attributes

This hash will contain the details of an investor's tax residency. An investor can provide up to four tax residency details in the investor_profile object.

Name Mandatory Type Remarks
country yes string ANSI code of the tax residency country
taxid_type yes enum Tax Identification type.

If country is IN, then allowed values are - passport, election_id, pan, id_card, driving_license, aadhaar_letter, nrega_job_card, others, not_categorized, tin

Else, allowed values are - passport, id_card, driving_license, others, not_categorized, tin
taxid_number yes string Tax Identification number issued against ID mentioned in taxid_type


NOTE:

use_default_tax_residences is only an input parameter and not a part of the investor_profile object


A note on working with Tax Residences

Details of at least one tax residency are mandatory to submit FATCA, irrespective of the tax status. While creating or modifying an investor profile, you can ask FP to assume default tax residency details. In such cases, tax residency will be treated as India and PAN will be used as the Tax Identification type provided that the PAN number is present in the investor profile. Else, if you want to input tax residency details on your own, you can override this and provide custom tax residency details. You can make use of the use_default_tax_residences input parameter to control this behaviour while creating or modifying an investor profile.

first_tax_residency attributes Default values
country IN
taxid_type pan
taxid_number investor.pan


The default tax residency values can be set only for the resident_individual tax status. In cases of tax status being resident_minor or non_resident_minor_nro, the corresponding guardian's tax residency details are to be mentioned.

Modify an Investor Profile

curl -X PATCH "https://s.finprim.com/v2/investor_profiles"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer ACCESS_TOKEN"
  -d '{json_request}'

JSON Request

{
  "id": "invp_9abd706565144b83947f4b498bc95e98",
  "income_slab": "above_1lakh_upto_5lakh"
}

PATCH /v2/investor_profiles

This API can be used to modify an investor profile.

Body parameters

Name Mandatory Type Comments
id yes string ID of an investor_profile object

Other input parameters and response are same as Create an Investor Profile API

NOTE:

You cannot modify the attribute type that is present in the investor_profile object.

Fetch an Investor Profile

curl -X GET "https://s.finprim.com/v2/investor_profiles/invp_9abd706565144b83947f4b498bc95e98"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer ACCESS_TOKEN"

JSON Response

{
  "object": "investor_profile",
  "id": "invp_9abd706565144b83947f4b498bc95e98",
  "type": "individual",
  "tax_status": "resident_individual",
  "name": "Tony Soprano",
  "date_of_birth": "2002-09-18",
  "gender": "male",
  "occupation": "business",
  "pan": "DWEPS2837G",
  "guardian_name": null,
  "guardian_date_of_birth": null,
  "guardian_pan": null,
  "signature": null,
  "country_of_birth": "IN",
  "place_of_birth": "IN",
  "first_tax_residency": {
    "country": "IN",
    "taxid_type": "pan",
    "taxid_number": "DWEPS2837G"
  },
  "second_tax_residency": null,
  "third_tax_residency": null,
  "fourth_tax_residency": null,
  "source_of_wealth": "salary",
  "income_slab": "upto_1lakh",
  "pep_details": "not_applicable",
  "employer": null,
  "ip_address": "192.92.12.39",
  "created_at": "2022-07-07T10:28:53+05:30"
}

GET /v2/investor_profiles/:id

This API can be used to fetch an investor profile.

Query parameters

Name Mandatory Type Comments
id yes string ID of an investor profile

List all Investor Profiles

curl -X GET "https://s.finprim.com/v2/investor_profiles"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer ACCESS_TOKEN"

JSON Response

{
  "object": "list",
  "data": [
    {
      "object": "investor_profile",
      "id": "invp_9abd706565144b83947f4b498bc95e98",
      "type": "individual",
      "tax_status": "resident_individual",
      "name": "Tony Soprano",
      "date_of_birth": "2002-09-18",
      "gender": "male",
      "occupation": "business",
      "pan": "DWEPS2837G",
      "guardian_name": null,
      "guardian_date_of_birth": null,
      "guardian_pan": null,
      "signature": null,
      "country_of_birth": "IN",
      "place_of_birth": "IN",
      "first_tax_residency": {
        "country": "IN",
        "taxid_type": "pan",
        "taxid_number": "DWEPS2837G"
      },
      "second_tax_residency": null,
      "third_tax_residency": null,
      "fourth_tax_residency": null,
      "source_of_wealth": "salary",
      "income_slab": "upto_1lakh",
      "pep_details": "not_applicable",
      "employer": null,
      "ip_address": "192.92.12.39",
      "created_at": "2022-07-07T10:28:53+05:30"
    }
  ]
}

GET /v2/investor_profiles

This API can be used to fetch all the investor profiles.

Query parameters

Name Mandatory Type Comments
pan no string pan stored in the investor profile
type no string Type of the investor profile. It can be individual

NOTE: Either pan or type should be given as an input to retrieve a list of investor profiles.

Bank Accounts

Endpoints:

POST /v2/bank_accounts
PATCH /v2/bank_accounts
GET /v2/bank_accounts/:id
GET /v2/bank_accounts

Bank Account Object

Bank Account Object

{
  "object": "bank_account",
  "id": "bac_b58dca0f78d5432c907a85c8f8a1139e",
  "old_id": 906,
  "profile": "invp_9abd706565144b83947f4b498bc95e98",
  "primary_account_holder_name": "Tony Soprano",
  "account_number": "98123459204",
  "type": "savings",
  "ifsc_code": "HDFC0001330",
  "branch_name": "THE MALL CHHOTI BARADARI",
  "bank_name": "HDFC BANK",
  "branch_address": "3THE MALLCHHOTI BARADARI",
  "branch_contact_number": "9815331111",
  "branch_city": "PATIALA",
  "branch_district": "PATIALA",
  "branch_state": "PUNJAB",
  "cancelled_cheque": null,
  "sole_proprietorship": "sopr_1985fcb8f9ae4623b7720a151b58b924",
  "created_at": "2022-12-06T12:10:36+05:30"
}

This will contain the bank account details of the investor corresponding to the id of the linked investor_profile object.

Bank Account Object attributes

Name Type Comments
object string Value is bank_account. String representing the object type. Objects of the same type share the same value
id string Unique identifier of the bank_account object
old_id integer This is the numeric ID of this bank_account object. We have provided this as some of our APIs use this ID like in Payments and Mandate APIs.
profile string ID of the Investor profile to which this bank account belongs to
primary_account_holder_name string Primary account holder name
account_number string Bank account number
type string Allowed values are - savings, current, nre, nro
ifsc_code string IFSC code of the branch in which this bank account is present
branch_name string Branch name
bank_name string Bank name
branch_address string Branch address
branch_contact_number string Branch contact number
branch_city string Branch city
branch_district string Branch district
branch_state string Branch state
cancelled_cheque string V2 File ID of the cancelled cheque
sole_proprietorship string V2 ID of a sole_proprietorship object.

NOTE: The attribute sole_proprietorship is available under beta program.
created_at string Creation timestamp

Create a Bank Account

curl -X POST "https://s.finprim.com/v2/bank_accounts"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer ACCESS_TOKEN"
  -d '{json_request}'

JSON Request

{
  "profile": "invp_9abd706565144b83947f4b498bc95e98",
  "primary_account_holder_name": "Tony Soprano",
  "account_number": "98123459204",
  "type": "savings",
  "ifsc_code": "HDFC0001330",
  "sole_proprietorship": "sopr_1985fcb8f9ae4623b7720a151b58b924"
}

JSON Response

{
  "object": "bank_account",
  "id": "bac_b58dca0f78d5432c907a85c8f8a1139e",
  "old_id": 906,
  "profile": "invp_9abd706565144b83947f4b498bc95e98",
  "primary_account_holder_name": "Tony Soprano",
  "account_number": "98123459204",
  "type": "savings",
  "ifsc_code": "HDFC0001330",
  "branch_name": "THE MALL CHHOTI BARADARI",
  "bank_name": "HDFC BANK",
  "branch_address": "3THE MALLCHHOTI BARADARI",
  "branch_contact_number": "9815331111",
  "branch_city": "PATIALA",
  "branch_district": "PATIALA",
  "branch_state": "PUNJAB",
  "cancelled_cheque": null,
  "sole_proprietorship": "sopr_1985fcb8f9ae4623b7720a151b58b924",
  "created_at": "2022-12-06T12:10:36+05:30"
}

POST /v2/bank_accounts

This API can be used to create a bank_account object.

Request Parameters

Name Mandatory Type Comments
profile yes string ID of the Investor profile to which this bank account belongs to.

Once set, this cannot be modified.
account_number yes string Bank account number This should only contain integer
Min and Max character length is 9 and 18

Once set, this cannot be modified.
primary_account_holder_name yes string Primary account holder name

Once set, this cannot be modified.
type yes string Allowed values are - savings, current, nre, nro

Once set, this cannot be modified.
ifsc_code yes string IFSC code of the branch in which this bank account is present.

Once set, this cannot be modified.
cancelled_cheque no string File ID of the cancelled cheque
sole_proprietorship no string ID of a sole_proprietorship object

Modify a Bank Account

curl -X PATCH "https://s.finprim.com/v2/bank_accounts"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer ACCESS_TOKEN"
  -d '{json_request}'

JSON Request

{
  "id": "bac_b58dca0f78d5432c907a85c8f8a1139e",
  "cancelled_cheque": "file_98367e8972b43867a9c68a7c4605a31d"
}

JSON Response

{
  "object": "bank_account",
  "id": "bac_b58dca0f78d5432c907a85c8f8a1139e",
  "old_id": 906,
  "profile": "invp_9abd706565144b83947f4b498bc95e98",
  "primary_account_holder_name": "Tony Soprano",
  "account_number": "98123459204",
  "type": "savings",
  "ifsc_code": "HDFC0001330",
  "branch_name": "THE MALL CHHOTI BARADARI",
  "bank_name": "HDFC BANK",
  "branch_address": "3THE MALLCHHOTI BARADARI",
  "branch_contact_number": "9815331111",
  "branch_city": "PATIALA",
  "branch_district": "PATIALA",
  "branch_state": "PUNJAB",
  "cancelled_cheque": "file_98367e8972b43867a9c68a7c4605a31d",
  "sole_proprietorship": "sopr_1985fcb8f9ae4623b7720a151b58b924",
  "created_at": "2022-12-06T12:10:36+05:30"
}

PATCH /v2/bank_accounts

This API can be used to modify the details of a bank account object. You can add and modify cancelled cheque for a bank account object.

Body parameters

Name Mandatory Type Comments
id yes string ID of a bank_account object
cancelled_cheque yes string File ID of the cancelled cheque


NOTE:

For a given bank_account object, at any given time you cannot modify any other attributes other than cancelled_cheque


Fetch a Bank Account

curl -X GET "https://s.finprim.com/v2/bank_accounts/bac_b58dca0f78d5432c907a85c8f8a1139e"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer ACCESS_TOKEN"

JSON Response

{
  "object": "bank_account",
  "id": "bac_b58dca0f78d5432c907a85c8f8a1139e",
  "old_id": 906,
  "profile": "invp_9abd706565144b83947f4b498bc95e98",
  "primary_account_holder_name": "Tony Soprano",
  "account_number": "98123459204",
  "type": "savings",
  "ifsc_code": "HDFC0001330",
  "branch_name": "THE MALL CHHOTI BARADARI",
  "bank_name": "HDFC BANK",
  "branch_address": "3THE MALLCHHOTI BARADARI",
  "branch_contact_number": "9815331111",
  "branch_city": "PATIALA",
  "branch_district": "PATIALA",
  "branch_state": "PUNJAB",
  "cancelled_cheque": null,
  "sole_proprietorship": "sopr_1985fcb8f9ae4623b7720a151b58b924",
  "created_at": "2022-12-06T12:10:36+05:30"
}

GET /v2/bank_accounts/:id

This API can be used to fetch the details of a bank account.

Query parameters

Name Mandatory Type Comments
id yes string ID of a bank_account object

List all Bank Accounts

curl -X GET "https://s.finprim.com/v2/bank_accounts"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer ACCESS_TOKEN"

JSON Response

{
  "object": "list",
  "data": [
    {
      "object": "bank_account",
      "id": "bac_b58dca0f78d5432c907a85c8f8a1139e",
      "profile": "invp_9abd706565144b83947f4b498bc95e98",
      "old_id": 906,
      "primary_account_holder_name": "Tony Soprano",
      "account_number": "98123459204",
      "type": "savings",
      "ifsc_code": "HDFC0001330",
      "branch_name": "THE MALL CHHOTI BARADARI",
      "bank_name": "HDFC BANK",
      "branch_address": "3THE MALLCHHOTI BARADARI",
      "branch_contact_number": "9815331111",
      "branch_city": "PATIALA",
      "branch_district": "PATIALA",
      "branch_state": "PUNJAB",
      "cancelled_cheque": null,
      "sole_proprietorship": "sopr_1985fcb8f9ae4623b7720a151b58b924",
      "created_at": "2022-12-06T12:10:36+05:30"
    }
  ]
}

GET /v2/bank_accounts

This API can be used to fetch all the bank accounts.

Query parameters

Name Mandatory Type Comments
profile yes string id of an investor profile

Addresses

Endpoints:

POST /v2/addresses
PATCH /v2/addresses
GET /v2/addresses/:id
GET /v2/addresses

Address Object

Address Object

{
  "object": "address",
  "id": "addr_4a9ac8e2c88b40be8a0470534d5499d6",
  "profile": "invp_9abd706565144b83947f4b498bc95e98",
  "line1": "342, 2nd main, 1st cross",
  "line2": "JP Nagar 2nd phase",
  "line3": null,
  "city": "Bengaluru",
  "state": "KARNATAKA",
  "postal_code": "560078",
  "country": "IN",
  "nature": "residential",
  "created_at": "2022-12-06T12:19:36+05:30"
}

This object can be used to store an investor's address details.

Address object attributes

Name Type Comments
object string Value is address. String representing the object type. Objects of the same type share the same value
id string Unique identifier of the address object
profile string ID of the Investor profile to which this address belongs to
line1 string Address line 1
line2 string Address line 2
line3 string Address line 3
city string City
state string State
postal_code string Pincode
country string Country ANSI Code
nature enum Allowed values for investor_profile are residential, business_location.
Allowed values for investor_profile_non_individual are registered_office, business_location
created_at string Creation timestamp

Create an Address

POST /v2/addresses

curl -X POST "https://s.finprim.com/v2/addresses"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer ACCESS_TOKEN"
  -d '{json_request}'

JSON Request

{
  "profile": "invp_9abd706565144b83947f4b498bc95e98",
  "line1": "342, 2nd main, 1st crosss",
  "line2": "JP Nagar 2nd phase",
  "country": "IN",
  "postal_code": "560078",
  "nature": "residential"
}

JSON Response

{
  "object": "address",
  "id": "addr_4a9ac8e2c88b40be8a0470534d5499d6",
  "profile": "invp_9abd706565144b83947f4b498bc95e98",
  "line1": "342, 2nd main, 1st cross",
  "line2": "JP Nagar 2nd phase",
  "line3": null,
  "city": "Bengaluru",
  "state": "KARNATAKA",
  "postal_code": "560078",
  "country": "IN",
  "nature": "residential",
  "created_at": "2022-12-06T12:19:36+05:30"
}

This API can be used to create an address object.

Request Parameters

Name Mandatory Type Comments
profile yes string ID of the Investor profile to which this address belongs to.

Once set, this cannot be modified.
line1 yes string Address line 1

Once set, this cannot be modified.
line2 no string Address line 2

Once set, this cannot be modified.
line3 no string Address line 3

Once set, this cannot be modified.
city no string City

Once set, this cannot be modified.
state no string State

Once set, this cannot be modified.
postal_code yes string Pincode

Once set, this cannot be modified.
country yes string Country ANSI Code

Once set, this cannot be modified.
nature no enum Allowed values for investor_profile are residential, business_location.
Allowed values for investor_profile_non_individual are registered_office, business_location.
Once set, this cannot be modified.


If country=IN and an Indian postal_code is mentioned, the fields - city and state would be auto-populated from the postal_code provided.

Modify an Address

curl -X PATCH "https://s.finprim.com/v2/addresses"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer ACCESS_TOKEN"
  -d '{json_request}'

JSON Request

{
  "id": "addr_4a9ac8e2c88b40be8a0470534d5499d6",
  "line3": "RK Colony"
}

JSON Response

{
  "object": "address",
  "id": "addr_4a9ac8e2c88b40be8a0470534d5499d6",
  "profile": "invp_9abd706565144b83947f4b498bc95e98",
  "line1": "342, 2nd main, 1st cross",
  "line2": "JP Nagar 2nd phase",
  "line3": "RK Colony",
  "city": "Bengaluru",
  "state": "KARNATAKA",
  "postal_code": "560078",
  "country": "IN",
  "nature": "residential",
  "created_at": "2022-12-06T12:19:36+05:30"
}

PATCH /v2/addresses

This API can be used to modify the details of an address object. All the non-mandatory paramters can be added using this API, but once set they cannot be modified .

Body parameters

Name Mandatory Type Comments
id yes string ID of an address object

Other input parameters are same as Create an Address API

Fetch an Address

curl -X GET "https://s.finprim.com/v2/addresses/addr_4a9ac8e2c88b40be8a0470534d5499d6"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer ACCESS_TOKEN"

JSON Response

{
  "object": "address",
  "id": "addr_4a9ac8e2c88b40be8a0470534d5499d6",
  "profile": "invp_9abd706565144b83947f4b498bc95e98",
  "line1": "342, 2nd main, 1st cross",
  "line2": "JP Nagar 2nd phase",
  "line3": null,
  "city": "Bengaluru",
  "state": "KARNATAKA",
  "postal_code": "560078",
  "country": "IN",
  "nature": "residential",
  "created_at": "2022-12-06T12:19:36+05:30"
}

GET /v2/addresses/:id

This API can be used to fetch the details of an address.

Query parameters

Name Mandatory Type Comments
id yes string ID of an address object

List all Addresses

curl -X GET "https://s.finprim.com/v2/addresses"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer ACCESS_TOKEN"

JSON Response

{
  "object": "list",
  "data": [
    {
      "object": "address",
      "id": "addr_4a9ac8e2c88b40be8a0470534d5499d6",
      "profile": "invp_9abd706565144b83947f4b498bc95e98",
      "line1": "342, 2nd main, 1st crosss",
      "line2": "JP Nagar 2nd phase",
      "line3": null,
      "city": "Bengaluru",
      "state": "KARNATAKA",
      "postal_code": "560078",
      "country": "IN",
      "nature": "residential",
      "created_at": "2022-12-06T12:19:36+05:30"
    }
  ]
}

GET /v2/addresses

This API can be used to fetch all the addresses.

Query parameters

Name Mandatory Type Comments
profile yes string id of an investor profile

Phone Numbers

Endpoints:

POST /v2/phone_numbers
PATCH /v2/phone_numbers
GET /v2/phone_numbers/:id
GET /v2/phone_numbers

Phone Number Object

Phone Number Object

{
  "object": "phone_number",
  "id": "phone_0f4a90134705474eb2e354d9b5ba5f56",
  "profile": "invp_9abd706565144b83947f4b498bc95e98",
  "isd": "91",
  "number": "9012893478",
  "belongs_to": "self",
  "created_at": "2022-12-06T12:19:36+05:30"
}

This object can be used to store an investor's phone number.

Phone Number object attributes

Name Type Comments
object string Value is phone_number. String representing the object type. Objects of the same type share the same value
id string Unique identifier of the phone_number object
profile string ID of the Investor profile to which this phone number is linked to
isd string ISD code of the phone number
number string Phone number
belongs_to enum Indicate to whom this phone number belongs to

Allowed values are self, spouse, dependent_children, dependent_siblings, dependent_parents, guardian, pms, custodian, poa
created_at string Creation timestamp

Create a Phone Number

curl -X POST "https://s.finprim.com/v2/phone_numbers"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer ACCESS_TOKEN"
  -d '{json_request}'

JSON Request

{
  "profile": "invp_9abd706565144b83947f4b498bc95e98",
  "isd": "91",
  "number": "9012893478"
}

JSON Response

{
  "object": "phone_number",
  "id": "phone_0f4a90134705474eb2e354d9b5ba5f56",
  "profile": "invp_9abd706565144b83947f4b498bc95e98",
  "isd": "91",
  "number": "9012893478",
  "belongs_to": null,
  "created_at": "2022-12-06T12:19:36+05:30"
}

POST /v2/phone_numbers

This API can be used to create a phone_number object.

Request Parameters

Name Mandatory Type Comments
profile yes string ID of the Investor profile to which this phone number is linked to.

Once set, this cannot be modified.
isd yes string ISD code of the phone number. Only integers are allowed, also + can be added at the start.
Max character length is 4 including +

Once set, this cannot be modified.
number yes string Phone number Only integers and - are allowed
Min and Max character length is 7 and 20

Once set, this cannot be modified.
belongs_to no enum Indicates to whom this phone number belongs to. Once set, this cannot be modified.

Allowed values are self, spouse, dependent_children, dependent_siblings, dependent_parents, guardian, pms, custodian, poa

Modify a Phone Number

curl -X PATCH "https://s.finprim.com/v2/phone_numbers"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer ACCESS_TOKEN"
  -d '{json_request}'

JSON Request

{
  "id": "phone_0f4a90134705474eb2e354d9b5ba5f56",
  "belongs_to": "self"
}

JSON Response

{
  "object": "phone_number",
  "id": "phone_0f4a90134705474eb2e354d9b5ba5f56",
  "profile": "invp_9abd706565144b83947f4b498bc95e98",
  "isd": "91",
  "number": "9012893478",
  "belongs_to": "self",
  "created_at": "2022-12-06T12:19:36+05:30"
}

PATCH /v2/phone_numbers

This API can be used to modify a phone number object. You can add belongs_to for an email address object but once set this cannot be modified.

Body parameters

Name Mandatory Type Comments
id yes string ID of a phone_number object
belongs_to yes string Indicates to whom this phone number belongs to. Once set, this cannot be modified.

Allowed values are self, spouse, dependent_children, dependent_siblings, dependent_parents, guardian, pms, custodian, poa

Fetch a Phone Number

curl -X GET "https://s.finprim.com/v2/phone_numbers/phone_0f4a90134705474eb2e354d9b5ba5f56"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer ACCESS_TOKEN"

JSON Response

{
  "object": "phone_number",
  "id": "phone_0f4a90134705474eb2e354d9b5ba5f56",
  "profile": "invp_9abd706565144b83947f4b498bc95e98",
  "isd": "91",
  "number": "9012893478",
  "belongs_to": "self",
  "created_at": "2022-12-06T12:19:36+05:30"
}

GET /v2/phone_numbers/:id

This API can be used to fetch the details of a phone number.

Query parameters

Name Mandatory Type Comments
id yes string ID of a phone_number object

List all Phone Numbers

curl -X GET "https://s.finprim.com/v2/phone_numbers"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer ACCESS_TOKEN"

JSON Response

{
  "object": "list",
  "data": [
    {
      "object": "phone_number",
      "id": "phone_0f4a90134705474eb2e354d9b5ba5f56",
      "profile": "invp_9abd706565144b83947f4b498bc95e98",
      "isd": "91",
      "number": "9012893478",
      "belongs_to": "self",
      "created_at": "2022-12-06T12:19:36+05:30"
    }
  ]
}

GET /v2/phone_numbers

This API can be used to fetch all the phone numbers.

Query parameters

Name Mandatory Type Comments
profile yes string id of an investor profile

Email Addresses

Endpoints:

POST /v2/email_addresses
PATCH /v2/email_addresses
GET /v2/email_addresses/:id
GET /v2/email_addresses

Email Address Object

Email Address Object

{
  "object": "email_address",
  "id": "email_122133976adb4f3083e25da895e99293",
  "profile": "invp_9abd706565144b83947f4b498bc95e98",
  "email": "tony.soprano@gmail.com",
  "belongs_to": "self",
  "created_at": "2022-12-06T12:19:36+05:30"
}

This object can be used to store an investor's email addresses.

Email Address object attributes

Name Type Comments
object string Value is email_address. String representing the object type. Objects of the same type share the same value
id string Unique identifier of the email_address object
profile string ID of the Investor profile to which this email address is linked to
email string Email address
belongs_to enum Indicate to whom this email address belongs to

Allowed values are self, spouse, dependent_children, dependent_siblings, dependent_parents, guardian, pms, custodian, poa
created_at string Creation timestamp

Create an Email Address

curl -X POST "https://s.finprim.com/v2/email_addresses"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer ACCESS_TOKEN"
  -d '{json_request}'

JSON Request

{
  "profile": "invp_9abd706565144b83947f4b498bc95e98",
  "email": "tony.soprano@gmail.com"
}

JSON Response

{
  "object": "email_address",
  "id": "email_122133976adb4f3083e25da895e99293",
  "profile": "invp_9abd706565144b83947f4b498bc95e98",
  "email": "tony.soprano@gmail.com",
  "belongs_to": null,
  "created_at": "2022-12-06T12:19:36+05:30"
}

POST /v2/email_addresses

This API can be used to create a email_address object.

Request Parameters

Name Mandatory Type Comments
profile yes string ID of the Investor profile to which this email address is linked to.

Once set, this cannot be modified.
email yes string Email address

Once set, this cannot be modified.
belongs_to no enum Indicates to whom this email address belongs to. Once set, this cannot be modified.

Allowed values are self, spouse, dependent_children, dependent_siblings, dependent_parents, guardian, pms, custodian, poa

Modify an Email Address

curl -X PATCH "https://s.finprim.com/v2/email_addresses"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer ACCESS_TOKEN"
  -d '{json_request}'

JSON Request

{
  "id": "email_122133976adb4f3083e25da895e99293",
  "belongs_to": "self"
}

JSON Response

{
  "object": "email_address",
  "id": "email_122133976adb4f3083e25da895e99293",
  "profile": "invp_9abd706565144b83947f4b498bc95e98",
  "email": "tony.soprano@gmail.com",
  "belongs_to": "self",
  "created_at": "2022-12-06T12:19:36+05:30"
}

PATCH /v2/email_addresses

This API can be used to modify an email address object. You can add belongs_to for an email address object but once set this cannot be modified.

Body parameters

Name Mandatory Type Comments
id yes string ID of an email_address object
belongs_to yes string Indicates to whom this email address belongs to. Once set, this cannot be modified.

Allowed values are self, spouse, dependent_children, dependent_siblings, dependent_parents, guardian, pms, custodian, poa

Fetch an Email Address

curl -X GET "https://s.finprim.com/v2/email_addresses/email_122133976adb4f3083e25da895e99293"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer ACCESS_TOKEN"

JSON Response

{
  "object": "email_address",
  "id": "email_122133976adb4f3083e25da895e99293",
  "profile": "invp_9abd706565144b83947f4b498bc95e98",
  "email": "tony.soprano@gmail.com",
  "belongs_to": "self",
  "created_at": "2022-12-06T12:19:36+05:30"
}

GET /v2/email_addresses/:id

This API can be used to fetch the details of an email address.

Query parameters

Name Mandatory Type Comments
id yes string ID of an email_address object

List all Email Addresses

curl -X GET "https://s.finprim.com/v2/email_addresses"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer ACCESS_TOKEN"

JSON Response

{
  "object": "list",
  "data": [
    {
      "object": "email_address",
      "id": "email_122133976adb4f3083e25da895e99293",
      "profile": "invp_9abd706565144b83947f4b498bc95e98",
      "email": "tony.soprano@gmail.com",
      "belongs_to": "self",
      "created_at": "2022-12-06T12:19:36+05:30"
    }
  ]
}

GET /v2/email_addresses

This API can be used to fetch all the email addresses.

Query parameters

Name Mandatory Type Comments
profile yes string id of an investor profile

Related Parties

Endpoints:

POST /v2/related_parties
PATCH /v2/related_parties
GET /v2/related_parties/:id
GET /v2/related_parties

JSON Response

{
  "object": "related_party",
  "id": "relp_3c1f0c0b0f15474e90baf9f32692c6eb",
  "profile": "invp_9abd706565144b83947f4b498bc95e98",
  "name": "Ram Sharma",
  "relationship": "son",
  "date_of_birth": "2002-02-29",
  "pan": "ASFPJ2398R",
  "guardian_name": null,
  "guardian_pan": null,
  "created_at": "2022-12-06T12:26:41+05:30",
  "aadhaar_number": null,
  "passport_number": null,
  "driving_licence_number": null,
  "email_address": "ram@gmail.com",
  "phone_number": {
    "isd": "+91",
    "number": "9092390923"
  },
  "address": {
    "line1": "213, 1st cross, JP Nagar",
    "line2": null,
    "line3": null,
    "city": "Bengaluru",
    "state": "Karnataka",
    "postal_code": "560102",
    "country": "in"
  },
  "guardian_aadhaar_number": null,
  "guardian_passport_number": null,
  "guardian_driving_licence_number": null,
  "guardian_email_address": null,
  "guardian_phone_number": null,
  "guardian_address": null
}

This object can be used to store any person or a party related to an investor. These related parties could be used for nominations declared by the investor.

Name Type Comments
object string Value is related_party. String representing the object type. Objects of the same type share the same value
id string Unique identifier of the related_party object
profile string ID of the Investor profile to which this party is related to
name string Name of the related party
relationship string Relation of this party with the investor. Allowed values are father, mother, court_appointed_legal_guardian, aunt, brother_in_law,brother, daughter, daughter_in_law, father_in_law, grand_daughter, grand_father, grand_mother, grand_son, mother_in_law, nephew, niece, sister, sister_in_law, son, son_in_law, spouse, uncle, others
date_of_birth date Date of birth of the related party
pan string PAN of the related party
guardian_name string Name of the Guardian if the related party is a minor
This should not be same as Name in Investor profile object
guardian_pan string PAN of the Guardian if the related party is a minor
This should not be same as PAN in Investor profile object
created_at string Creation timestamp
aadhaar_number string Last 4 digits of related party's Aadhaar number
passport_number string Passport number of the related party
driving_licence_number string Driving Licence number of the related party
email_address string Email address of the related party
phone_number hash Phone number of the related party
address hash Address of the related party
guardian_aadhaar_number string Last 4 digits of guardian's Aadhaar number if the related party is a minor
guardian_passport_number string Passport number of the guardian if the related party is a minor
guardian_driving_licence_number string Driving Licence number of the guardian if the related party is a minor
guardian_email_address string Email address of the guardian if the related party is a minor
guardian_phone_number hash Phone number of the guardian if the related party is a minor
guardian_address hash Address of the guardian if the related party is a minor
curl -X POST "https://s.finprim.com/v2/related_parties"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer ACCESS_TOKEN"
  -d '{json_request}'

JSON Request

{
  "profile": "invp_9abd706565144b83947f4b498bc95e98",
  "name": "Ram Sharma",
  "date_of_birth": "2002-02-29",
  "relationship": "son"
}

JSON Response

{
  "object": "related_party",
  "id": "relp_3c1f0c0b0f15474e90baf9f32692c6eb",
  "profile": "invp_9abd706565144b83947f4b498bc95e98",
  "name": "Ram Sharma",
  "relationship": "son",
  "date_of_birth": "2002-02-29",
  "pan": null,
  "guardian_name": null,
  "guardian_pan": null,
  "created_at": "2022-12-06T12:26:41+05:30",
  "aadhaar_number": null,
  "passport_number": null,
  "driving_licence_number": null,
  "email_address": null,
  "phone_number": null,
  "address": null,
  "guardian_aadhaar_number": null,
  "guardian_passport_number": null,
  "guardian_driving_licence_number": null,
  "guardian_email_address": null,
  "guardian_phone_number": null,
  "guardian_address": null
}

POST /v2/related_parties

This API can be used to create a related_party object.

Request Parameters

Name Mandatory Type Comments
profile yes string ID of the Investor profile to which this party is related to.

Once set, this cannot be modified.
name yes string Name of the related party. This should not contain any special characters or numbers.
Max character length is 40

Once set, this cannot be modified.
relationship yes enum Relation of this party with the investor. Allowed values are father, mother, court_appointed_legal_guardian, aunt, brother_in_law,brother, daughter, daughter_in_law, father_in_law, grand_daughter, grand_father, grand_mother, grand_son, mother_in_law, nephew, niece, sister, sister_in_law, son, son_in_law, spouse, uncle, others

Once set, this cannot be modified.
date_of_birth no date Date of birth of the related party. This should be given in the format yyyy-mm-dd

Once set, this cannot be modified.
pan no string PAN of the related party. Can be given only if related party age > 18 years

Once set, this cannot be modified.
guardian_name no string Name of the related party's guardian. Can be given only if related party age < 18 years. This should not contain any special characters or numbers.
Max character length is 35

Once set, this cannot be modified.
guardian_pan no string PAN of the Guardian. Can be given only if related party age < 18 years.

Once set, this cannot be modified.
aadhaar_number no string Last 4 digits of related party's Aadhaar number. Can be given only if relatedparty age > 18 years

Once set, this cannot be modified.
passport_number no string Passport number of the related party. Can be given only if related party age > 18 years

Once set, this cannot be modified.
driving_licence_number no string Driving Licence number of the related party. Can be given only if related party age > 18 years

Once set, this cannot be modified.
email_address no string Email address of the related party. Can be given only if related party age > 18 years

Once set, this cannot be modified.
phone_number no hash Phone number of the related party. Can be given only if related party age > 18 years

Once set, this cannot be modified.
address no hash Address of the related party. Can be given only if related party age > 18 years

Once set, this cannot be modified.
guardian_aadhaar_number no string Last 4 digits of guardian's Aadhaar number. Can be given only if related party age < 18 years.

Once set, this cannot be modified.
guardian_passport_number no string Passport number of the Guardian. Can be given only if related party age < 18 years.

Once set, this cannot be modified.
guardian_driving_licence_number no string Driving Licence number of the Guardian. Can be given only if related party age < 18 years.

Once set, this cannot be modified.
guardian_email_address no string Email address of the Guardian. Can be given only if related party age < 18 years.

Once set, this cannot be modified.
guardian_phone_number no hash Phone number of the Guardian. Can be given only if related party age < 18 years.

Once set, this cannot be modified.
guardian_address no hash Address of the Guardian. Can be given only if related party age < 18 years.

Once set, this cannot be modified.

Phone Number / Guardian Phone Number hash attributes

Name Mandatory Type Comments
isd yes string ISD code of the phone number. Only integers are allowed, also + can be added at the start
number yes string Phone number. Only integers and - are allowed

Address / Guardian Address hash attributes

Name Mandatory Type Comments
line1 yes string Address line 1. Mandatory
line2 no string Address line 2
line3 no string Address line 3
city no string City
state no string State
postal_code yes string Pincode. Mandatory
country yes string Country ANSI Code. Mandatory

NOTE: Any one among the supported identity proofs should be collected for a related party (or guardian in case of minor related party) before attempting a new folio creation request.

curl -X PATCH "https://s.finprim.com/v2/related_parties"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer ACCESS_TOKEN"
  -d '{json_request}'

JSON Request

{
  "id": "relp_3c1f0c0b0f15474e90baf9f32692c6eb",
  "pan": "ASFPJ2398R",
  "_comment": "Upcoming attributes listed below",
  "email_address": "ram@gmail.com",
  "phone_number": {
    "isd": "+91",
    "number": "9092390923"
  },
  "address": {
    "line1": "213, 1st cross, JP Nagar",
    "postal_code": "560102",
    "country": "in"
  }
}

JSON Response

{
  "object": "related_party",
  "id": "relp_3c1f0c0b0f15474e90baf9f32692c6eb",
  "profile": "invp_9abd706565144b83947f4b498bc95e98",
  "name": "Ram Sharma",
  "relationship": "son",
  "date_of_birth": "2002-02-29",
  "pan": "ASFPJ2398R",
  "guardian_name": null,
  "guardian_pan": null,
  "created_at": "2022-12-06T12:26:41+05:30",
  "aadhaar_number": null,
  "passport_number": null,
  "driving_licence_number": null,
  "email_address": "ram@gmail.com",
  "phone_number": {
    "isd": "+91",
    "number": "9092390923"
  },
  "address": {
    "line1": "213, 1st cross, JP Nagar",
    "line2": null,
    "line3": null,
    "city": "Bengaluru",
    "state": "Karnataka",
    "postal_code": "560102",
    "country": "in"
  },
  "guardian_aadhaar_number": null,
  "guardian_passport_number": null,
  "guardian_driving_licence_number": null,
  "guardian_email_address": null,
  "guardian_phone_number": null,
  "guardian_address": null
}

PATCH /v2/related_parties

This API can be used to modify the details of a related party object. All the non-mandatory paramters can be added using this API, but once set they cannot be modified .

Body parameters

Name Mandatory Type Comments
id yes string ID of a related_party object

Other input parameters and the response are same as Create a Related Party API

curl -X GET "https://s.finprim.com/v2/related_parties/relp_3c1f0c0b0f15474e90baf9f32692c6eb"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer ACCESS_TOKEN"

JSON Response

{
  "object": "related_party",
  "id": "relp_3c1f0c0b0f15474e90baf9f32692c6eb",
  "profile": "invp_9abd706565144b83947f4b498bc95e98",
  "name": "Ram Sharma",
  "relationship": "son",
  "date_of_birth": "2002-02-29",
  "pan": "ASFPJ2398R",
  "guardian_name": null,
  "guardian_pan": null,
  "created_at": "2022-12-06T12:26:41+05:30",
  "aadhaar_number": null,
  "passport_number": null,
  "driving_licence_number": null,
  "email_address": "ram@gmail.com",
  "phone_number": {
    "isd": "+91",
    "number": "9092390923"
  },
  "address": {
    "line1": "213, 1st cross, JP Nagar",
    "line2": null,
    "line3": null,
    "city": "Bengaluru",
    "state": "Karnataka",
    "postal_code": "560102",
    "country": "in"
  },
  "guardian_aadhaar_number": null,
  "guardian_passport_number": null,
  "guardian_driving_licence_number": null,
  "guardian_email_address": null,
  "guardian_phone_number": null,
  "guardian_address": null
}

GET /v2/related_parties/:id

This API can be used to fetch the details of a related party.

Query parameters

Name Mandatory Type Comments
id yes string ID of a related_party object
curl -X GET "https://s.finprim.com/v2/related_parties"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer ACCESS_TOKEN"

JSON Response

{
  "object": "list",
  "data": [
    {
      "object": "related_party",
      "id": "relp_3c1f0c0b0f15474e90baf9f32692c6eb",
      "profile": "invp_9abd706565144b83947f4b498bc95e98",
      "name": "Ram Sharma",
      "relationship": "son",
      "date_of_birth": "2002-02-29",
      "pan": null,
      "guardian_name": null,
      "guardian_pan": null,
      "created_at": "2022-12-06T12:26:41+05:30",
      "aadhaar_number": null,
      "passport_number": null,
      "driving_licence_number": null,
      "email_address": null,
      "phone_number": null,
      "address": null,
      "guardian_aadhaar_number": null,
      "guardian_passport_number": null,
      "guardian_driving_licence_number": null,
      "guardian_email_address": null,
      "guardian_phone_number": null,
      "guardian_address": null
    }
  ]
}

GET /v2/related_parties

This API can be used to fetch all the related parties.

Query parameters

Name Mandatory Type Comments
profile yes string id of an investor profile

MF Investment Accounts

You need to create an investment account for your investors before you can start accepting orders. Any orders placed via an investment account and folios associated with those orders are organized under the investment account. When you migrate folios, folios having the same pans and holding pattern combination are organized under the investment accounts of matching pans and holding pattern. mf_investment_account object represents such investment accounts.

Endpoints:

POST /v2/mf_investment_accounts
PATCH /v2/mf_investment_accounts
GET /v2/mf_investment_accounts/:id
GET /v2/mf_investment_accounts

MF Investment Account Object

{
  "object": "mf_investment_account",
  "id": "mfia_14bafabfbfbc423d9b54412dd577981b",
  "old_id": 110,
  "primary_investor_pan": "ACCPP55K7L",
  "second_investor_pan": null,
  "third_investor_pan": null,
  "primary_investor_old_id": null,
  "second_investor_old_id": null,
  "third_investor_old_id": null,
  "primary_investor": "invp_c55240e4b09d4617812bb9557b399a42",
  "second_investor": null,
  "third_investor": null,
  "holding_pattern": "single",
  "folio_defaults": {
    "communication_email_address": "email_bf1026954d0545e190727de1537d9e66",
    "communication_mobile_number": "phone_0f4a90134705474eb2e354d9b5ba5f56",
    "communication_address": "addr_8c50b6930ebf4ec7a7ddd58c34bdf1d8",
    "overseas_communication_address": "addr_bf1026954d0545e190727de1537d9e66",
    "payout_bank_account": "bac_8c50b6930ebf4ec7a7ddd58c34bdf1d8",
    "nominee1": "relp_8c50b6930ebf4ec7a7ddd58c34bdf1d8",
    "nominee1_allocation_percentage": 100,
    "nominee2": null,
    "nominee2_allocation_percentage": null,
    "nominee3": null,
    "nominee3_allocation_percentage": null,
    "demat_account": "dac_156e3c3bb66e447d8fe7e44d7d941f5a",
    "nominee1_identity_proof_type": "pan",
    "nominee1_guardian_identity_proof_type": null,
    "nominee2_identity_proof_type": null,
    "nominee2_guardian_identity_proof_type": null,
    "nominee3_identity_proof_type": null,
    "nominee3_guardian_identity_proof_type": null,
    "nominations_info_visibility": "show_all_nominee_names"
  },
  "created_at": "2020-04-06T15:32:52+05:30"
}
Attribute Type Comments
object string Value is mf_investment_account. String representing the object type. Objects of the same type share the same value
id string Unique identifier of the mf_investment_account object
old_id integer This is the numeric ID of this mf_investment_account object. We have provided this as some of our APIs use this ID like in holding API.
primary_investor_pan string PAN of the first holder
second_investor_pan string PAN of the second holder
third_investor_pan string PAN of the third holder
primary_investor_old_id (Deprecated) string Identifier of the first holder old investor object attached to this investment account
second_investor_old_id (Deprecated) string Identifier of the second holder old investor object attached to this investment account
third_investor_old_id (Deprecated) string Identifier of the third holder old investor object attached to this investment account
primary_investor string Identifier of the first holder's investor profile object or identifier of the non individual investor profile object.
If you are using investor profile, then it is mandatory input if primary_investor_old_id is not given
second_investor string Identifier of the second holder's investor profile object
third_investor string Identifier of the third holder's investor profile t
holding_pattern string This value indicates the holding nature of the folios that are mapped against this investment account. For example, if the holding pattern is single, you can create transactions against investor's folios where the investor is the primary investor and holding pattern is single.
Possible values: single, joint, either_or_survivor, anyone_or_survivor, first_or_survivor
For non individual investor profiles, only single holding_pattern is supported.
folio_defaults hash This hash contains the transaction data preferences that can be set
created_at string The time at which the investment_account is created

Folio Defaults hash

This hash will contain a set of attributes which can be set as default data values that would be used while submitting transaction requests.

Attribute Type Comments
communication_email_address string email_address object ID that contains a valid email address to which all the communications would be sent to.
communication_mobile_number string phone_number object ID that contains a valid mobile number to which all the communications would be sent to.
communication_address string address object ID that contains a valid address to which all the communications would be sent to.
overseas_communication_address string address object ID that contains a valid overseas communication address if any present
payout_bank_account string bank_account object ID that contains a valid bank account to which payouts will be made
nominee1 string related_party object ID that contains nominee information
nominee1_allocation_percentage numeric Allocation percentage for Nominee 1
nominee2 string related_party object ID that contains nominee information
nominee2_allocation_percentage numeric Allocation percentage for Nominee 2
nominee3 string related_party object ID that contains nominee information
nominee3_allocation_percentage numeric Allocation percentage for Nominee 3
demat_account string demat_account object ID that contains the demat account details of the investor.
If this attribute has demat_account object ID, then any new folio and respective orders using the investment account will be treated for delivery in demat mode, else folio and respective orders will be treated for delivery in physical mode
nominee1_identity_proof_type enum Mandatory if the nominee is not a minor. Allowed values are pan / aadhaar / driving_licence / passport. The respective proof number should be specified in the mentioned related_party for the proof type given here
nominee1_guardian_identity_proof_type enum Mandatory if the nominee is a minor. Supported values are pan / aadhaar / driving_licence / passport. The respective proof number should be specified in the mentioned related_party for the proof type given here
nominee2_identity_proof_type enum Mandatory if the nominee is not a minor. Allowed values are pan / aadhaar / driving_licence / passport. The respective proof number should be specified in the mentioned related_party for the proof type given here
nominee2_guardian_identity_proof_type enum Mandatory if the nominee is a minor. Supported values are pan / aadhaar / driving_licence / passport. The respective proof number should be specified in the mentioned related_party for the proof type given here
nominee3_identity_proof_type enum Mandatory if the nominee is not a minor. Allowed values are pan / aadhaar / driving_licence / passport. The respective proof number should be specified in the mentioned related_party for the proof type given here
nominee3_guardian_identity_proof_type enum Mandatory if the nominee is a minor. Supported values are pan / aadhaar / driving_licence / passport. The respective proof number should be specified in the mentioned related_party for the proof type given here
nominations_info_visibility enum Declaration on whether the investor wants to display nomination status or all nominees' names on the statement of accounts.Allowed values are - show_all_nominee_names, show_nomination_status

A note on working with Folio Defaults

Every Investor Profile that is created, has a capability where multiple values can be registered against a certain set of attributes. While this investor wants to make a transaction, he should be able to choose one among those values to register against his order. For ex., if an investor profile has 5 addresses present, he should be able to choose one among them as the communication_address and another as the overseas_communication_address, to send it as the supporting data for the transaction that he is making. FP has a capability of recording a set of default values that can be defined and used every time while making a transaction. You can choose to update these values as and when necessary.

Please note that, the folio_defaults behaviour is limited to investment accounts which are created using Investor Profile IDs alone. If you are creating an investment account with with investor ID(old investor object), all the attributes in folio_defaults hash would be set to null.


Create an MF Investment Account

POST /v2/mf_investment_accounts

curl -X POST "https://s.finprim.com/v2/mf_investment_accounts"
  -H "x-tenant-id: <tenant name>"
  -H "Authorization: Bearer ACCESS_TOKEN"

JSON Request:

{
  "primary_investor": "invp_c55240e4b09d4617812bb9557b399a42",
  "holding_pattern": "single"
}

JSON Response:

{
  "object": "mf_investment_account",
  "id": "mfia_14bafabfbfbc423d9b54412dd577981b",
  "old_id": 110,
  "primary_investor_pan": "ACCPP55K7L",
  "second_investor_pan": null,
  "third_investor_pan": null,
  "primary_investor_old_id": null,
  "second_investor_old_id": null,
  "third_investor_old_id": null,
  "primary_investor": "invp_c55240e4b09d4617812bb9557b399a42",
  "second_investor": null,
  "third_investor": null,
  "holding_pattern": "single",
  "folio_defaults": {
    "communication_email_address": null,
    "communication_mobile_number": null,
    "communication_address": null,
    "overseas_communication_address": null,
    "payout_bank_account": null,
    "nominee1": null,
    "nominee1_allocation_percentage": null,
    "nominee2": null,
    "nominee2_allocation_percentage": null,
    "nominee3": null,
    "nominee3_allocation_percentage": null,
    "demat_account": null,
    "nominee1_identity_proof_type": null,
    "nominee1_guardian_identity_proof_type": null,
    "nominee2_identity_proof_type": null,
    "nominee2_guardian_identity_proof_type": null,
    "nominee3_identity_proof_type": null,
    "nominee3_guardian_identity_proof_type": null,
    "nominations_info_visibility": null
  },
  "created_at": "2020-04-06T15:32:52+05:30"
}

Request Parameters

Name Mandatory Type Comments
primary_investor yes string Investor profile ID of the first holder.
holding_pattern no string Provide holding pattern for the investment account.
Default value = single
Supported values: single
folio_defaults no hash This hash contains the transaction data preferences that can be set. This can be set only if primary_investor is given

Folio Defaults hash

Attribute Mandatory Type Comments
communication_email_address no string email_address object ID that contains a valid email address to which all the communications would be sent to.
communication_mobile_number no string phone_number object ID that contains a valid mobile number to which all the communications would be sent to.
communication_address no string address object ID that contains a valid address to which all the communications would be sent to.
overseas_communication_address no string address object ID that contains a valid overseas communication address if any present
payout_bank_account no string bank_account object ID that contains a valid bank account to which payouts will be made
nominee1 no string related_party object ID that contains nominee information
nominee1_allocation_percentage no numeric Allocation percentage for Nominee 1
nominee2 no string related_party object ID that contains nominee information
nominee2_allocation_percentage no numeric Allocation percentage for Nominee 2
nominee3 no string related_party object ID that contains nominee information
nominee3_allocation_percentage no numeric Allocation percentage for Nominee 3
demat_account no string demat_account object ID that contains the demat account details of the investor.
If this attribute has demat_account object ID, then any new folio and respective orders using the investment account will be treated for delivery in demat mode, else folio and respective orders will be treated for delivery in physical mode
nominee1_identity_proof_type no enum Mandatory if the nominee is not a minor. Allowed values are pan / aadhaar / driving_licence / passport. The respective proof number should be specified in the mentioned related_party for the proof type given here
nominee1_guardian_identity_proof_type no enum Mandatory if the nominee is a minor. Supported values are pan / aadhaar / driving_licence / passport. The respective proof number should be specified in the mentioned related_party for the proof type given here
nominee2_identity_proof_type no enum Mandatory if the nominee is not a minor. Allowed values are pan / aadhaar / driving_licence / passport. The respective proof number should be specified in the mentioned related_party for the proof type given here
nominee2_guardian_identity_proof_type no enum Mandatory if the nominee is a minor. Supported values are pan / aadhaar / driving_licence / passport. The respective proof number should be specified in the mentioned related_party for the proof type given here
nominee3_identity_proof_type no enum Mandatory if the nominee is not a minor. Allowed values are pan / aadhaar / driving_licence / passport. The respective proof number should be specified in the mentioned related_party for the proof type given here
nominee3_guardian_identity_proof_type no enum Mandatory if the nominee is a minor. Supported values are pan / aadhaar / driving_licence / passport. The respective proof number should be specified in the mentioned related_party for the proof type given here
nominations_info_visibility no enum Declaration on whether the investor wants to display nomination status or all nominees' names on the statement of accounts. Allowed values are - show_all_nominee_names, show_nomination_status

Note: Investor Details Validation

In accordance with "AMFI Best Practice Guidelines Circular No.97 /2021-22 published on March 28, 2022", FP performs following validations while creating/updating an investment account .

Attribute Validation
Investor Name
  • Name must not contain special characters such as : %, [ , . , = , & , - , \ , /, _ , : , ; , ?, ( , @ , * , + , ) , # , ! , $ , ^ , ] , ", and ,
  • Guardian Name
  • Name must not contain special characters.
  • Name should not be same as investor name.
  • Nominee Name
  • Name must not contain special characters.
  • Name should not be same as investor name.
  • If more than one nominee, Nominee names should be Unique.
  • Investor Mobile Number For indian numbers, i.e isd_code = 91
  • Acceptable length of the Mobile number is 10 digits.
  • Mobile number should not start with 0 or 1 or 2 or 3 or 4 or 5.
  • All the digits in a Mobile number should not be the same. (Example: 7777777777 is an invalid number)
  • Investor Email
  • A valid structured email address should be present in investor contact details. (Example: values like notprovided, noemail or empty will be considered invalid email)
  • The email address must contain exactly one occurence of '@' symbol. (Example: mf@investor@gmail.com is an invalid email address)
  • Email address must not end with a dot. (Example: mfinvestor@gmail.com. is an invalid email address)
  • Email address must not end with an invalid Top Level Domain. (Whitelisted TLD's : .com, .in, .org, .co, .net, .edu, .me, .uk)
  • Update an MF Investment Account

    PATCH /v2/mf_investment_accounts

    This API lets you associate an investor with an investment account. This will be necessary when you avail FP's folio migration facility.

    This API can also be used to set or modify the folio_defaults that is present in an investment account object. In order to do this, the investment account should contain a valid Investor Profile ID in primary_investor attribute.

    curl -X PATCH "https://s.finprim.com/v2/mf_investment_accounts"
      -H "x-tenant-id: <tenant name>"
      -H "Authorization: Bearer ACCESS_TOKEN"
    

    JSON Request:

    {
      "id": "mfia_14bafabfbfbc423d9b54412dd577981b",
      "folio_defaults": {
        "communication_email_address": "email_bf1026954d0545e190727de1537d9e66",
        "communication_mobile_number": "phone_0f4a90134705474eb2e354d9b5ba5f56",
        "communication_address": "addr_8c50b6930ebf4ec7a7ddd58c34bdf1d8",
        "overseas_communication_address": "addr_bf1026954d0545e190727de1537d9e66",
        "payout_bank_account": "bac_8c50b6930ebf4ec7a7ddd58c34bdf1d8",
        "nominee1": "relp_8c50b6930ebf4ec7a7ddd58c34bdf1d8",
        "nominee1_allocation_percentage": 100,
        "demat_account": "dac_156e3c3bb66e447d8fe7e44d7d941f5a",
        "_comment": "Upcoming attributes listed below",
        "nominee1_identity_proof_type": null,
        "nominations_info_visibility": "show_all_nominee_names"
      }
    }
    

    JSON Response:

    {
      "object": "mf_investment_account",
      "id": "mfia_14bafabfbfbc423d9b54412dd577981b",
      "old_id": 110,
      "primary_investor_pan": "ACCPP55K7L",
      "second_investor_pan": null,
      "third_investor_pan": null,
      "primary_investor_old_id": null,
      "second_investor_old_id": null,
      "third_investor_old_id": null,
      "primary_investor": "invp_c55240e4b09d4617812bb9557b399a42",
      "second_investor": null,
      "third_investor": null,
      "holding_pattern": "single",
      "folio_defaults": {
        "communication_email_address": "email_bf1026954d0545e190727de1537d9e66",
        "communication_mobile_number": "phone_0f4a90134705474eb2e354d9b5ba5f56",
        "communication_address": "addr_8c50b6930ebf4ec7a7ddd58c34bdf1d8",
        "overseas_communication_address": "addr_bf1026954d0545e190727de1537d9e66",
        "payout_bank_account": "bac_8c50b6930ebf4ec7a7ddd58c34bdf1d8",
        "nominee1": "relp_8c50b6930ebf4ec7a7ddd58c34bdf1d8",
        "nominee1_allocation_percentage": 100,
        "nominee2": null,
        "nominee2_allocation_percentage": null,
        "nominee3": null,
        "nominee3_allocation_percentage": null,
        "demat_account": "dac_156e3c3bb66e447d8fe7e44d7d941f5a",
        "nominee1_identity_proof_type": "pan",
        "nominee1_guardian_identity_proof_type": null,
        "nominee2_identity_proof_type": null,
        "nominee2_guardian_identity_proof_type": null,
        "nominee3_identity_proof_type": null,
        "nominee3_guardian_identity_proof_type": null,
        "nominations_info_visibility": "show_all_nominee_names"
      },
      "created_at": "2020-04-06T15:32:52+05:30"
    }
    

    Request Parameters

    Name Mandatory Type Comments
    id yes string ID of the investment account.
    primary_investor no string Provide Investor Profile ID of the first holder. The PAN of the investor should match with the primary_investor_pan of the investment account.
    Once a value is set, this cannot be modified.
    folio_defaults no hash This hash contains the transaction data preferences that can be set. This can be given only if primary_investor is being set or it already has a Investor Profile ID set.

    You cannot define folio_defaults if a value for primary_investor_old_id is set.

    Folio Defaults hash

    Attribute Mandatory Type Comments
    communication_email_address no string email_address object ID that contains a valid email address to which all the communications would be sent to.
    communication_mobile_number no string phone_number object ID that contains a valid mobile number to which all the communications would be sent to.
    communication_address no string address object ID that contains a valid address to which all the communications would be sent to.
    overseas_communication_address no string address object ID that contains a valid overseas communication address if any present
    payout_bank_account no string bank_account object ID that contains a valid bank account to which payouts will be made
    nominee1 no string related_party object ID that contains nominee information
    nominee1_allocation_percentage no numeric Allocation percentage for Nominee 1
    nominee2 no string related_party object ID that contains nominee information
    nominee2_allocation_percentage no numeric Allocation percentage for Nominee 2
    nominee3 no string related_party object ID that contains nominee information
    nominee3_allocation_percentage no numeric Allocation percentage for Nominee 3
    demat_account no string demat_account object ID that contains the demat account details of the investor.
    If this attribute has demat_account object ID, then any new folio and respective orders using the investment account will be treated for delivery in demat mode, else folio and respective orders will be treated for delivery in physical mode
    nominee1_identity_proof_type no enum Mandatory if the nominee is not a minor. Allowed values are pan / aadhaar / driving_licence / passport. The respective proof number should be specified in the mentioned related_party for the proof type given here
    nominee1_guardian_identity_proof_type no enum Mandatory if the nominee is a minor. Supported values are pan / aadhaar / driving_licence / passport. The respective proof number should be specified in the mentioned related_party for the proof type given here
    nominee2_identity_proof_type no enum Mandatory if the nominee is not a minor. Allowed values are pan / aadhaar / driving_licence / passport. The respective proof number should be specified in the mentioned related_party for the proof type given here
    nominee2_guardian_identity_proof_type no enum Mandatory if the nominee is a minor. Supported values are pan / aadhaar / driving_licence / passport. The respective proof number should be specified in the mentioned related_party for the proof type given here
    nominee3_identity_proof_type no enum Mandatory if the nominee is not a minor. Allowed values are pan / aadhaar / driving_licence / passport. The respective proof number should be specified in the mentioned related_party for the proof type given here
    nominee3_guardian_identity_proof_type no enum Mandatory if the nominee is a minor. Supported values are pan / aadhaar / driving_licence / passport. The respective proof number should be specified in the mentioned related_party for the proof type given here
    nominations_info_visibility no enum Declaration on whether the investor wants to display nomination status or all nominees' names on the statement of accounts. Allowed values are - show_all_nominee_names, show_nomination_status

    Note:

    Validations performed during Create a mf investment account , are also applied while Update a mf investment account.

    A note on mapping existing investment accounts with newly onboarded investors

    When folios are migrated, corresponding investment accounts are created and folios are organized under the investment accounts. No investor objects are created. Therefore, there will be investment accounts without any investor associated with them. When you onboard an investor, you can search whether there are any investment accounts are present or not. If they are present, you can associate an investor or an investor profile with the investment account using this API.

    Fetch an MF Investment Account

    GET /v2/mf_investment_accounts/:id

    This API is used to fetch a given investment account by its V2 identifier.

    curl -X GET "https://s.finprim.com/v2/mf_investment_accounts/mfia_14bafabfbfbc423d9b54412dd577981b"
      -H "x-tenant-id: <tenant name>"
      -H "Authorization: Bearer ACCESS_TOKEN"
    

    JSON Response:

    {
      "object": "mf_investment_account",
      "id": "mfia_14bafabfbfbc423d9b54412dd577981b",
      "old_id": 110,
      "primary_investor_pan": "ACCPP55K7L",
      "second_investor_pan": null,
      "third_investor_pan": null,
      "primary_investor_old_id": null,
      "second_investor_old_id": null,
      "third_investor_old_id": null,
      "primary_investor": "invp_c55240e4b09d4617812bb9557b399a42",
      "second_investor": null,
      "third_investor": null,
      "holding_pattern": "single",
      "folio_defaults": {
        "communication_email_address": "email_bf1026954d0545e190727de1537d9e66",
        "communication_mobile_number": "phone_0f4a90134705474eb2e354d9b5ba5f56",
        "communication_address": "addr_8c50b6930ebf4ec7a7ddd58c34bdf1d8",
        "overseas_communication_address": "addr_bf1026954d0545e190727de1537d9e66",
        "payout_bank_account": "bac_8c50b6930ebf4ec7a7ddd58c34bdf1d8",
        "nominee1": "relp_8c50b6930ebf4ec7a7ddd58c34bdf1d8",
        "nominee1_allocation_percentage": 100,
        "nominee2": null,
        "nominee2_allocation_percentage": null,
        "nominee3": null,
        "nominee3_allocation_percentage": null,
        "demat_account": "dac_156e3c3bb66e447d8fe7e44d7d941f5a",
        "nominee1_identity_proof_type": "pan",
        "nominee1_guardian_identity_proof_type": null,
        "nominee2_identity_proof_type": null,
        "nominee2_guardian_identity_proof_type": null,
        "nominee3_identity_proof_type": null,
        "nominee3_guardian_identity_proof_type": null,
        "nominations_info_visibility": "show_all_nominee_names"
      },
      "created_at": "2020-04-06T15:32:52+05:30"
    }
    

    Query Parameters

    Name Mandatory Type Comments
    mf_investment_account_id yes string V2 or V1 id of the investment account

    List all MF Investment Accounts

    GET /v2/mf_investment_accounts

    curl -X GET "https://s.finprim.com/v2/mf_investment_accounts"
      -H "x-tenant-id: <tenant name>"
      -H "Authorization: Bearer ACCESS_TOKEN"
    

    JSON Response:

    {
      "object": "list",
      "data": [
        {
          "object": "mf_investment_account",
          "id": "mfia_14bafabfbfbc423d9b54412dd577981b",
          "old_id": 110,
          "primary_investor_pan": "ACCPP55K7L",
          "second_investor_pan": null,
          "third_investor_pan": null,
          "primary_investor_old_id": null,
          "second_investor_old_id": null,
          "third_investor_old_id": null,
          "primary_investor": "invp_c55240e4b09d4617812bb9557b399a42",
          "second_investor": null,
          "third_investor": null,
          "holding_pattern": "single",
          "folio_defaults": {
            "communication_email_address": "email_bf1026954d0545e190727de1537d9e66",
            "communication_mobile_number": "phone_0f4a90134705474eb2e354d9b5ba5f56",
            "communication_address": "addr_8c50b6930ebf4ec7a7ddd58c34bdf1d8",
            "overseas_communication_address": "addr_bf1026954d0545e190727de1537d9e66",
            "payout_bank_account": "bac_8c50b6930ebf4ec7a7ddd58c34bdf1d8",
            "nominee1": "relp_8c50b6930ebf4ec7a7ddd58c34bdf1d8",
            "nominee1_allocation_percentage": 100,
            "nominee2": null,
            "nominee2_allocation_percentage": null,
            "nominee3": null,
            "nominee3_allocation_percentage": null,
            "demat_account": "dac_156e3c3bb66e447d8fe7e44d7d941f5a",
            "nominee1_identity_proof_type": "pan",
            "nominee1_guardian_identity_proof_type": null,
            "nominee2_identity_proof_type": null,
            "nominee2_guardian_identity_proof_type": null,
            "nominee3_identity_proof_type": null,
            "nominee3_guardian_identity_proof_type": null,
            "nominations_info_visibility": "show_all_nominee_names"
          },
          "created_at": "2020-04-06T15:32:52+05:30"
        },
        {
          "object": "mf_investment_account",
          "id": "mfia_24bafbbfbfbc423d9b54412dc57a9a11",
          "old_id": 111,
          "primary_investor_pan": "PCCPK55K7L",
          "second_investor_pan": null,
          "third_investor_pan": null,
          "primary_investor_old_id": 111,
          "second_investor_old_id": null,
          "third_investor_old_id": null,
          "primary_investor": null,
          "second_investor": null,
          "third_investor": null,
          "holding_pattern": "single",
          "folio_defaults": {
            "communication_email_address": null,
            "communication_mobile_number": null,
            "communication_address": null,
            "overseas_communication_address": null,
            "payout_bank_account": null,
            "nominee1": null,
            "nominee1_allocation_percentage": null,
            "nominee2": null,
            "nominee2_allocation_percentage": null,
            "nominee3": null,
            "nominee3_allocation_percentage": null,
            "demat_account": null,
            "nominee1_identity_proof_type": null,
            "nominee1_guardian_identity_proof_type": null,
            "nominee2_identity_proof_type": null,
            "nominee2_guardian_identity_proof_type": null,
            "nominee3_identity_proof_type": null,
            "nominee3_guardian_identity_proof_type": null,
[...]
